package com.qmth.distributed.print.business.activiti.custom.service;

import org.activiti.bpmn.model.MultiInstanceLoopCharacteristics;
import org.activiti.bpmn.model.UserTask;

/**
 * @Description: 创建并行/串行业务
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2022/2/8
 */
public interface DefaultInstanceConvertToMultiInstance extends MultiWorkFlow {

    public static final String ASSIGNEE_USER = "assignee";

    public static final String DEFAULT_ASSIGNEE_LIST = "assigneeList";

    public static final String DEFAULT_ASSIGNEE_LIST_EXP = "${assigneeList";

    public static final String ASSIGNEE_USER_EXP = "${" + ASSIGNEE_USER;

    public static final String EXP_SUFFIX = "}";

    /**
     * 创建 多实例 行为解释器
     *
     * @param userTask
     * @param sequential
     * @return
     */
    UserTask createMultiInstanceBehavior(UserTask userTask, boolean sequential);

    /**
     * 创建多实例行为解释器
     *
     * @param userTask        流程节点
     * @param sequential      是否串行
     * @param assigneeListExp 用户组表达
     * @param assigneeExp     用户标识
     * @return
     */
    UserTask createMultiInstanceBehavior(UserTask userTask, boolean sequential, String assigneeListExp, String assigneeExp);

    /**
     * 创建多实例 循环解释器
     *
     * @param isSequential    是否串行
     * @param assigneeListExp 用户组表达
     * @param assignee        用户标识
     * @return
     */
    MultiInstanceLoopCharacteristics createMultiInstanceLoopCharacteristics(boolean isSequential, String assigneeListExp, String assignee);

    /**
     * 创建多实例 循环解释器
     *
     * @param id
     * @param isSequential 是否 串行
     * @return
     */
    MultiInstanceLoopCharacteristics createMultiInstanceLoopCharacteristics(String id, boolean isSequential);
}
